import java.io.IOException;
import java.io.OutputStream;
import java.net.InetSocketAddress;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import com.sun.net.httpserver.Headers;
import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;
import com.sun.net.httpserver.HttpServer;

import javax.json.Json;
import javax.json.JsonArrayBuilder;
import javax.json.JsonObject;
import javax.json.JsonObjectBuilder;
import javax.json.JsonWriter;

public class Test {

  static class DataHandler implements HttpHandler {
    public void handle(HttpExchange ex) {
      JsonObject response = Json.createObjectBuilder()
        .add("ok", true)
        .build();
      byte[] responseBytes = response.toString().getBytes();

      // Send the headers
      try {
        Headers headers = ex.getResponseHeaders();
        headers.set("Content-Type", "application/json");
        // Needed to keep CORS happy
        headers.set("Access-Control-Allow-Methods", "GET");
        headers.set("Access-Control-Allow-Origin", "*");
        ex.sendResponseHeaders(200, responseBytes.length);

        // Send the body
        OutputStream os = ex.getResponseBody();
        os.write(responseBytes);
        os.close();
      } catch (IOException e) {
        System.err.println(e);
        return;
      }
    }
  }

  public static void main(String[] args) {
    // Try to set up a connection to the SQLite database
    Connection db = null;
    try {
      Class.forName("org.sqlite.JDBC");
      db = DriverManager.getConnection("jdbc:sqlite:../reports.db");

      Statement stmt = db.createStatement();
      ResultSet rows = stmt.executeQuery("SELECT count(*) AS count FROM reports");
      rows.next();
      int count = rows.getInt("count");

      if (count != 20000) {
        System.err.println("Unable to connect to connect to or read from sqlite3 database.  Please check your Java installation");
        return;
      }
    } catch (Exception e) {
      System.err.println(e);
      return;
    }

    System.out.println("sqlite3 OK, starting webserver");

    HttpServer server;
    try {
      server = HttpServer.create(new InetSocketAddress(3265), 0);
    } catch (Exception e) {
      System.err.println(e);
      return;
    }

    server.createContext("/test", new DataHandler());
    server.setExecutor(null);
    server.start();
  }
}
